﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraFlyer : MonoBehaviour {

	public float moveSpeedHorizontal = 2.0f;
	public float moveSpeedVertical = 2.0f;

	public float lookSpeedHorizontal = 2.0f;
	public float lookSpeedVertical = 2.0f;

	public bool invertAxisY = true;

	public GameObject pauseScreen;

	public KeyCode pauseButton = KeyCode.Space;

	private float yaw = 0.0f;
	private float pitch = 0.0f;

	private bool gamePaused;

	void Update () {

		if (Input.GetKeyDown(pauseButton)) {
			gamePaused = !gamePaused;
		}

		if (!gamePaused) {
			pauseScreen.SetActive(false);
			moveCamera();
		} else {
			pauseScreen.SetActive(true);
		}
	}



	private void moveCamera() {
		float lookHorizontal = lookSpeedHorizontal * Input.GetAxis("Mouse X");
		float lookVertical = lookSpeedVertical * Input.GetAxis("Mouse Y");

		int inverter = invertAxisY ? -1 : 1;

		yaw += lookHorizontal;
		pitch += inverter * lookVertical;

		transform.eulerAngles = new Vector3(pitch, yaw, 0.0f);

		float moveHorizontal = moveSpeedHorizontal * Input.GetAxis("Horizontal");
		float moveVertical = moveSpeedVertical * Input.GetAxis("Vertical");
		transform.position += Quaternion.Euler(transform.eulerAngles) * new Vector3(moveHorizontal, 0, moveVertical);
	}
}
